Attribute VB_Name = "mGlobal"
Option Base 0
Option Compare Binary
Option Explicit

Const FILE_BEGIN = 0
Const FILE_SHARE_READ = &H1
Const FILE_SHARE_WRITE = &H2
Const OPEN_EXISTING = 3
Const GENERIC_READ = &H80000000

Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

Declare Function LockWindowUpdate Lib "user32" (ByVal hwndLock As Long) As Long
Private Declare Function DrawFocusRect Lib "user32" (ByVal hdc As Long, lpRect As RECT) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Any) As Long
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Public Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Public Const SWP_FRAMECHANGED = &H20        '  The frame changed: send WM_NCCALCSIZE
Public Const SWP_DRAWFRAME = SWP_FRAMECHANGED
Public Const SWP_NOACTIVATE = &H10
Public Const SWP_NOMOVE = &H2
Public Const SWP_NOSIZE = &H1
Public Const SWP_NOZORDER = &H4
Public Const SWP_NOOWNERZORDER = &H200      '  Don't do owner Z ordering

Private Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, ByVal lpOverlapped As Any) As Long
Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Any, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function SetFilePointer Lib "kernel32" (ByVal hFile As Long, ByVal lDistanceToMove As Long, lpDistanceToMoveHigh As Long, ByVal dwMoveMethod As Long) As Long
Private Declare Function GetFileSize Lib "kernel32" (ByVal hFile As Long, lpFileSizeHigh As Long) As Long

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDst As Any, pSrc As Any, ByVal ByteLen As Long)

Public Enum Language
    LANGUAGE_HTML = 1
    LANGUAGE_VB = 2
End Enum
Public WordTree As Lib_Dictionary
Public WordsToAdd() As String

Public m_TextBox As Object
Public m_Dictionary As String
Public m_ShowOnTop As Boolean
Public bFileNotFound As Boolean
       
'------------------------------------------------------------------------------
'-- Variables
'------------------------------------------------------------------------------
'-- Const - Long
'------------------------------------------------------------------------------
    Const gconlng_GWL_EXSTYLE            As Long = (-20)
    Const gconlng_WS_EX_CLIENTEDGE       As Long = &H200
    Const gconlng_WS_EX_STATICEDGE       As Long = &H20000
    Const gconlng_SWP_FRAMECHANGED       As Long = &H20
    Const gconlng_SWP_NOACTIVATE         As Long = &H10
    Const gconlng_SWP_NOMOVE             As Long = &H2
    Const gconlng_SWP_NOOWNERZORDER      As Long = &H200      '  Don't do owner Z ordering
    Const gconlng_SWP_NOREDRAW           As Long = &H8
    Const gconlng_SWP_NOSIZE             As Long = &H1
    Const gconlng_SWP_NOZORDER           As Long = &H4
    Const gconlng_SWP_SHOWWINDOW         As Long = &H40

    '-- Used For Disabling The X Button On A Menu
    Private Const mconlng_MF_BYPOSITION  As Long = &H400&
    Private Const mconlng_MF_REMOVE      As Long = &H1000&
'
'------------------------------------------------------------------------------
'-- End Variables
'------------------------------------------------------------------------------


'------------------------------------------------------------------------------
'-- Function.......: pThinBorder
'--
'-- Description....: Gives A Control With An Hwnd A Thin Looking Border
'--
'-- Author, date...: Gary Noble (TDLcom) / 16-03-2002
'--
'-- Modifications..:
'--
'-- Arguments......: lHWND,bState
'--
'-- Returns........: Nothing
'------------------------------------------------------------------------------
Public Function pThinBorder(ByVal lHwnd As Long, ByVal bState As Boolean)
    Dim lS As Long
    
    '-------------------------------------------------------
    '-- Give A Control With An Hwnd A Thin Looking Border
    '-------------------------------------------------------
    lS = GetWindowLong(lHwnd, gconlng_GWL_EXSTYLE)
    
    If Not (bState) Then
        
        lS = lS Or gconlng_WS_EX_CLIENTEDGE And Not gconlng_WS_EX_STATICEDGE
    
    Else
        
        lS = lS Or gconlng_WS_EX_STATICEDGE And Not gconlng_WS_EX_CLIENTEDGE
    
    End If
    
    SetWindowLong lHwnd, gconlng_GWL_EXSTYLE, lS
    SetWindowPos lHwnd, 0, 0, 0, 0, 0, gconlng_SWP_NOMOVE Or gconlng_SWP_NOSIZE Or gconlng_SWP_NOOWNERZORDER Or gconlng_SWP_NOZORDER Or gconlng_SWP_FRAMECHANGED
    
End Function

'------------------------------------------------------------------------------
'-- Function.......: GenerateFontTBL
'--
'-- Description....: Generates The Font Table For A Richtext Box
'--
'-- Author, date...: Gary Noble (TDLcom) / 16-03-2002
'--
'-- Modifications..:
'--
'-- Arguments......: FontNames
'--
'-- Returns........: Nothing
'------------------------------------------------------------------------------
Public Function GenerateFontTBL(ParamArray FontNames() As Variant)
    Dim m_strResult As String
    Dim m_strItem   As String
    Dim m_varItem   As Variant
    Dim m_lngIndex  As Long
    
    m_strResult = "{\fonttbl"
    
    For Each m_varItem In FontNames
        m_strItem = "{\f" & m_lngIndex & "\fcharset0 " & m_varItem & ";}"
        m_strResult = m_strResult & m_strItem
        m_lngIndex = m_lngIndex + 1
    Next
    
    m_strResult = m_strResult & "}"
    GenerateFontTBL = m_strResult
    
End Function

'------------------------------------------------------------------------------
'-- Function.......: GenerateColorTBL
'--
'-- Description....: Generates The Colour Table For A Richtext Box
'--
'-- Author, date...: Gary Noble (TDLcom) / 16-03-2002
'--
'-- Modifications..:
'--
'-- Arguments......: Colors()
'--
'-- Returns........: Variant
'------------------------------------------------------------------------------
Public Function GenerateColorTBL(ParamArray Colors() As Variant)
    Dim m_strResult As String
    Dim m_strItem   As String
    Dim m_varItem   As Variant
    Dim m_lngRed    As Long, _
        m_lngGreen  As Long, _
        m_lngBlue   As Long
        
    m_strResult = "{{\colortbl ;"
    
    For Each m_varItem In Colors
        m_lngRed = m_varItem Mod 256
        m_lngGreen = m_varItem \ 256 Mod 256
        m_lngBlue = m_varItem \ 256 \ 256 Mod 256
        m_strItem = "\red" & m_lngRed & "\green" & m_lngGreen & "\blue" & m_lngBlue & ";"
        m_strResult = m_strResult & m_strItem
    Next
    
    m_strResult = m_strResult & "}}"
    GenerateColorTBL = m_strResult
    
End Function

'------------------------------------------------------------------------------
'-- Function.......: ReadFromFile
'--
'-- Description....: Opens And Returns The text Contained In A File
'--
'-- Author, date...: Gary Noble (TDLcom) / 16-03-2002
'--
'-- Modifications..:
'--
'-- Arguments......: FileName
'--
'-- Returns........: String
'------------------------------------------------------------------------------
Public Function ReadFromFile(Filename As String) As String
    
    Dim hFile As Long, bContent() As Byte
    Dim FileLenght As Long, result As Long

    hFile = CreateFile(Filename, GENERIC_READ, FILE_SHARE_READ Or FILE_SHARE_WRITE, ByVal 0&, OPEN_EXISTING, 0, 0)

    FileLenght = GetFileSize(hFile, 0)
    SetFilePointer hFile, 0, 0, FILE_BEGIN
    
    ReDim bContent(1 To FileLenght) As Byte
    
    ReadFile hFile, bContent(1), UBound(bContent), result, ByVal 0&
    If result <> UBound(bContent) Then MsgBox "Error reading file ..."
    
    CloseHandle hFile

    ReadFromFile = StrConv(bContent, vbUnicode)
    ReDim bContent(0) As Byte

End Function


'------------------------------------------------------------------------------
'-- Function.......: LoadWords
'--
'-- Description....: Loads words from a dictionary file and calculates
'--                  their soundex codes
'--
'-- Author, date...: Gary Noble (TDLcom) / 16-03-2002
'--
'-- Modifications..:
'--
'-- Arguments......: strDictionaryFile
'--
'-- Returns........: Nothing
'------------------------------------------------------------------------------
Sub LoadWords(strDictionaryFile As String)
    Dim iFreeFile As Integer
    Dim strLine As String
    Dim strSoundExCode As String

    Dim lRead As Long, lLen As Long, lThisRead As Long, lLastRead As Long
    Dim sBuf As String, iNextPos As Long, iLastPos As Long
    Dim sWord As String, sRemain As String
    
    bFileNotFound = False
    iFreeFile = FreeFile
    Set WordTree = New Lib_Dictionary
    
    On Error GoTo DiskErr
    
    '-- Open file for binary access:
    Open strDictionaryFile For Binary Access Read Lock Write As #iFreeFile
    lLen = LOF(iFreeFile)
    
    '-- Loop through the file, loading it up in chunks of 64k:
    Do While lRead < lLen
        lThisRead = 65536
        If lThisRead + lRead > lLen Then
            lThisRead = lLen - lRead
        End If
        If Not lThisRead = lLastRead Then
            sBuf = Space$(lThisRead)
        End If
        
        Get #iFreeFile, , sBuf
        lRead = lRead + lThisRead
        
        '-- Extract elements from string:
        iLastPos = 1
        Do
            iNextPos = InStr(iLastPos, sBuf, vbCrLf)
            If iNextPos = 0 Then
                If iLastPos < lThisRead Then
                   sRemain = Mid$(sBuf, iLastPos)
                End If
            Else
                sWord = Mid$(sBuf, iLastPos, iNextPos - iLastPos)
                If Len(sRemain) > 0 Then
                   sWord = sRemain & sWord
                   sRemain = ""
                End If
                strSoundExCode = SoundEx(sWord)
                WordTree.Add strSoundExCode, sWord
                iLastPos = iNextPos + 2
            End If
        Loop While Not (iNextPos = 0)
    Loop
    
    '-- any remainder needs to be added as a word:
    WordTree.Add SoundEx(sWord), sWord
    Close iFreeFile
    '-- Time taken
    'Debug.Print Timer - fT, WordTree.Count
        
    Exit Sub
DiskErr:
    If Err = 53 Then
        bFileNotFound = True
    End If
    Err.Raise Err.Number, "CodeViewSpellCheck", Err.Description
End Sub

'------------------------------------------------------------------------------
'-- Function.......: SaveWords
'--
'-- Description....: Saves Words  To The Dictionary File
'--
'-- Author, date...: Gary Noble (TDLcom) / 16-03-2002
'--
'-- Modifications..:
'--
'-- Arguments......: strDictionaryFile
'--
'-- Returns........: Nothing
'------------------------------------------------------------------------------
Sub SaveWords(strDictionaryFile As String)
    If bFileNotFound Then Exit Sub
    Dim iFreeFile As Integer
    Dim i As Long
    On Error Resume Next
    iFreeFile = FreeFile
    Open strDictionaryFile For Append As iFreeFile
    For i = 1 To UBound(WordsToAdd)
        Print #iFreeFile, WordsToAdd(i)
    Next
    Close iFreeFile
End Sub
'------------------------------------------------------------------------------
'-- Function.......: SoundEx
'--
'-- Description....: Display The Words
'--
'-- Author, date...: Gary Noble (TDLcom) / 16-03-2002
'--
'-- Modifications..:
'--
'-- Arguments......: strDictionaryFile
'--
'-- Returns........: Nothing
'------------------------------------------------------------------------------
Function SoundEx(sWord As String) As String
    Dim Num As String * 4 ' Holds the generated code
    Dim i As Long
    Dim J As Long
    Dim sChar As String
    Dim sLastChar As String
    On Error GoTo ErrHandler
    sLastChar = UCase$(Mid$(sWord, 1, 1)) ' Get the first letter
    LSet Num = sLastChar & "000"
        
    '-- Create the code starting at the second letter.
    J = 2
    For i = 2 To Len(sWord)
        sChar = UCase$(Mid$(sWord, i, 1))
        '-- If two letters that are the same are next to each other
        '-- only count one of them
        If Not (StrComp(sLastChar, sChar) = 0) Then
            If InStr("BFPV", sChar) Then
               Mid$(Num, J, 1) = "1"
               J = J + 1
            ElseIf InStr("CGJKQSXZ", sChar) Then
               Mid$(Num, J, 1) = "2"
               J = J + 1
            ElseIf InStr("DT", sChar) Then
               Mid$(Num, J, 1) = "3"
               J = J + 1
            ElseIf StrComp(sChar, "L") = 0 Then
               Mid$(Num, J, 1) = "4"
               J = J + 1
            ElseIf InStr("MN", sChar) Then
               Mid$(Num, J, 1) = "5"
               J = J + 1
            ElseIf StrComp(sChar, "R") = 0 Then
               Mid$(Num, J, 1) = "6"
               J = J + 1
            End If
            sLastChar = sChar
        End If
        '-- Don't try to build a SoundEx > 4 chars long
        If J = 5 Then Exit For
    Next
    
    '-- Return 4 char SoundEx code:
    SoundEx = Num
    Exit Function
ErrHandler:
    Err.Raise Err.Number, "CodeViewSpellCheck", Err.Description
End Function
